<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates/framework/base/icecap-backtrace/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../icecap_backtrace/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../icecap_backtrace/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../icecap_backtrace/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
</pre><pre class="rust"><code><span class="attribute">#![<span class="ident">no_std</span>]</span>
<span class="attribute">#![<span class="ident">feature</span>(<span class="ident">never_type</span>)]</span>

<span class="kw">use</span> <span class="ident">icecap_backtrace_types</span>::{<span class="ident">Entry</span>, <span class="ident">Error</span> <span class="kw">as</span> <span class="ident">BacktraceError</span>, <span class="ident">Preamble</span>};
<span class="kw">use</span> <span class="ident">icecap_runtime::debug_get_image_path</span>;

<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused_imports</span>)]</span>
<span class="kw">use</span> <span class="ident">icecap_backtrace_types::Postamble</span>;
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused_imports</span>)]</span>
<span class="kw">use</span> <span class="ident">icecap_runtime::debug_println</span>;

<span class="macro">cfg_if::cfg_if!</span> {
    <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span> {
        <span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">alloc</span>;

        <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">icecap_backtrace_types::Backtrace</span>;

        <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">collect</span>() -&gt; <span class="ident">Backtrace</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span><span class="op">&gt;</span> {
            <span class="macro">debug_println!</span>(<span class="string">&quot;warning: collecting backtrace&quot;</span>);
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">builder</span> <span class="op">=</span> <span class="ident">Backtrace::builder</span>(<span class="ident">preamble</span>());
            <span class="kw">let</span> <span class="ident">error</span> <span class="op">=</span> <span class="ident">collect_with</span>(<span class="op">|</span><span class="ident">entry</span><span class="op">|</span> {
                <span class="ident">builder</span>.<span class="ident">append</span>(<span class="ident">entry</span>);
                <span class="bool-val">true</span>
            });
            <span class="ident">builder</span>.<span class="ident">finalize</span>(<span class="ident">Postamble</span> { <span class="ident">error</span> })
        }
    }
}

<span class="macro">cfg_if::cfg_if!</span> {
    <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;postcard&quot;</span>)]</span> {
        <span class="kw">use</span> <span class="ident">icecap_runtime::debug_print</span>;

        <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">collect_and_send_with</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="ident">FnMut</span>(<span class="ident">u8</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">E</span><span class="op">&gt;</span>, <span class="ident">E</span><span class="op">&gt;</span>(
            <span class="kw-2">mut</span> <span class="ident">send_byte</span>: <span class="ident">F</span>,
        ) -&gt; <span class="ident">postcard::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
            <span class="ident">preamble</span>().<span class="ident">send</span>(<span class="kw-2">&amp;mut</span> <span class="ident">send_byte</span>)<span class="question-mark">?</span>;
            <span class="kw">let</span> <span class="ident">error</span> <span class="op">=</span> <span class="ident">collect_with</span>(<span class="op">|</span><span class="ident">entry</span><span class="op">|</span> <span class="ident">entry</span>.<span class="ident">send</span>(<span class="kw-2">&amp;mut</span> <span class="ident">send_byte</span>).<span class="ident">is_ok</span>());
            <span class="kw">let</span> <span class="ident">postamble</span> <span class="op">=</span> <span class="ident">Postamble</span> { <span class="ident">error</span> };
            <span class="ident">postamble</span>.<span class="ident">send</span>(<span class="kw-2">&amp;mut</span> <span class="ident">send_byte</span>)<span class="question-mark">?</span>;
            <span class="prelude-val">Ok</span>(())
        }

        <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">collect_and_print_hex</span>() -&gt; <span class="ident">postcard::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
            <span class="ident">collect_and_send_with</span>(<span class="op">|</span><span class="ident">b</span><span class="op">|</span> {
                <span class="macro">debug_print!</span>(<span class="string">&quot;{:02x}&quot;</span>, <span class="ident">b</span>);
                <span class="prelude-ty">Result</span>::<span class="op">&lt;</span><span class="kw">_</span>, <span class="op">!</span><span class="op">&gt;</span><span class="ident">::Ok</span>(())
            })
        }

        <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">collect_and_print_pretty_infallible</span>() {
            <span class="macro">debug_println!</span>(<span class="string">&quot;stack backtrace:&quot;</span>);
            <span class="macro">debug_print!</span>(<span class="string">&quot;    &quot;</span>);
            <span class="kw">let</span> <span class="ident">err_present</span> <span class="op">=</span> <span class="ident">collect_and_print_hex</span>().<span class="ident">is_err</span>();
            <span class="macro">debug_println!</span>(<span class="string">&quot;&quot;</span>);
            <span class="macro">debug_println!</span>(<span class="string">&quot;&quot;</span>);
            <span class="kw">if</span> <span class="ident">err_present</span> {
                <span class="macro">debug_println!</span>(<span class="string">&quot;(error encountered while collecting stack backtrace)&quot;</span>);
            }
        }
    }
}

<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
<span class="kw">fn</span> <span class="ident">preamble</span>() -&gt; <span class="ident">Preamble</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span><span class="op">&gt;</span> {
    <span class="ident">Preamble</span> {
        <span class="ident">image_path</span>: <span class="ident">debug_get_image_path</span>().<span class="ident">map</span>(<span class="ident">Result::ok</span>).<span class="ident">flatten</span>(),
    }
}

<span class="macro">cfg_if::cfg_if!</span> {
    <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unwinding&quot;</span>)]</span> {
        <span class="kw">use</span> <span class="ident">core::ffi::c_void</span>;

        <span class="kw">use</span> <span class="ident">unwinding::abi</span>::<span class="kw-2">*</span>;

        <span class="kw">use</span> <span class="ident">icecap_backtrace_types::StackFrame</span>;

        <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">collect_with</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="ident">FnMut</span>(<span class="ident">Entry</span>) -&gt; <span class="ident">bool</span><span class="op">&gt;</span>(<span class="ident">f</span>: <span class="ident">F</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">BacktraceError</span><span class="op">&gt;</span> {
            <span class="kw">struct</span> <span class="ident">CallbackData</span><span class="op">&lt;</span><span class="ident">F1</span><span class="op">&gt;</span> {
                <span class="ident">f</span>: <span class="ident">F1</span>,
            }

            <span class="kw">extern</span> <span class="string">&quot;C&quot;</span> <span class="kw">fn</span> <span class="ident">callback</span><span class="op">&lt;</span><span class="ident">F1</span>: <span class="ident">FnMut</span>(<span class="ident">Entry</span>) -&gt; <span class="ident">bool</span><span class="op">&gt;</span>(
                <span class="ident">unwind_ctx</span>: <span class="kw-2">&amp;mut</span> <span class="ident">UnwindContext</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>,
                <span class="ident">arg</span>: <span class="kw-2">*mut</span> <span class="ident">c_void</span>,
            ) -&gt; <span class="ident">UnwindReasonCode</span> {
                <span class="kw">let</span> <span class="ident">data</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="kw-2">&amp;mut</span> <span class="kw-2">*</span>(<span class="ident">arg</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">CallbackData</span><span class="op">&lt;</span><span class="ident">F1</span><span class="op">&gt;</span>) };
                <span class="kw">let</span> <span class="ident">ip</span> <span class="op">=</span> <span class="ident">_Unwind_GetIP</span>(<span class="ident">unwind_ctx</span>);
                <span class="kw">let</span> <span class="ident">success</span> <span class="op">=</span> (<span class="ident">data</span>.<span class="ident">f</span>)(<span class="ident">Entry</span> {
                    <span class="ident">stack_frame</span>: <span class="ident">StackFrame</span> {
                        <span class="ident">ip</span>,
                    },
                });
                <span class="kw">if</span> <span class="ident">success</span> {
                    <span class="ident">UnwindReasonCode::NO_REASON</span>
                } <span class="kw">else</span> {
                    <span class="macro">debug_println!</span>(<span class="string">&quot;error: failed to collect backtrace&quot;</span>);
                    <span class="comment">// TODO which is the most appropriate code here?</span>
                    <span class="ident">UnwindReasonCode::FATAL_PHASE2_ERROR</span>
                }
            }

            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">data</span> <span class="op">=</span> <span class="ident">CallbackData</span> { <span class="ident">f</span> };
            <span class="kw">let</span> <span class="ident">code</span> <span class="op">=</span> <span class="ident">_Unwind_Backtrace</span>(<span class="ident">callback</span>::<span class="op">&lt;</span><span class="ident">F</span><span class="op">&gt;</span>, <span class="kw-2">&amp;mut</span> <span class="ident">data</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="kw">_</span> <span class="kw">as</span> <span class="kw">_</span>);
            <span class="kw">match</span> <span class="ident">code</span> {
                <span class="ident">UnwindReasonCode::END_OF_STACK</span> =&gt; <span class="prelude-val">None</span>,
                <span class="kw">_</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">BacktraceError</span> {
                    <span class="ident">unwind_reason_code</span>: <span class="ident">code</span>.<span class="number">0</span>,
                }),
            }
        }
    } <span class="kw">else</span> {
        <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">collect_with</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="ident">FnMut</span>(<span class="ident">Entry</span>) -&gt; <span class="ident">bool</span><span class="op">&gt;</span>(<span class="ident">_f</span>: <span class="ident">F</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">BacktraceError</span><span class="op">&gt;</span> {
            <span class="prelude-val">None</span>
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="icecap_backtrace" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>